aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/lantiq/base-files/etc/hotplug.d/firmware
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/lantiq/base-files/etc/hotplug.d/firmware')
-rw-r--r--target/linux/lantiq/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom60
-rw-r--r--target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata51
2 files changed, 111 insertions, 0 deletions
diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
new file mode 100644
index 0000000..5f1cb00
--- /dev/null
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
@@ -0,0 +1,60 @@
+#!/bin/sh
+# based on gabors ralink wisoc implementation
+
+rt2x00_eeprom_die() {
+ echo "rt2x00 eeprom: " "$*"
+ exit 1
+}
+
+rt2x00_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local swab=$4
+ local mtd
+
+ . /lib/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ rt2x00_eeprom_die "no mtd device found for partition $part"
+
+ if [ $swab -gt 0 ]; then
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=2 skip=$offset count=$count conv=swab || \
+ rt2x00_eeprom_die "failed to extract from $mtd"
+ else
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count || \
+ rt2x00_eeprom_die "failed to extract from $mtd"
+ fi
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+. /lib/functions/lantiq.sh
+
+case "$FIRMWARE" in
+"RT2860.eeprom" )
+ local board=$(lantiq_board_name)
+ case $board in
+ ARV7510PW22|ARV7519PW|ARV752DPW|ARV752DPW22|VGV7519)
+ rt2x00_eeprom_extract "board_config" 520 256 1
+ ;;
+ ARV7525PW)
+ rt2x00_eeprom_extract "board_config" 1040 512 0
+ ;;
+ *)
+ rt2x00_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+"RT3062.eeprom" )
+ local board=$(lantiq_board_name)
+ case $board in
+ VGV7510KW22)
+ rt2x00_eeprom_extract "board_config" 520 256 1
+ ;;
+ *)
+ rt2x00_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac
diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
new file mode 100644
index 0000000..0d8084f
--- /dev/null
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Based on ar71xx 11-ath10k-caldata and 10-rt2x00-eeprom
+
+ath10k_caldata_die() {
+ echo "ath10k caldata: " "$*"
+ exit 1
+}
+
+ath10k_caldata_extract() {
+ local part=$1
+ local offset=$2
+ local mtd
+
+ . /lib/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ ath10k_caldata_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=2116 || \
+ ath10k_caldata_die "failed to extract from $mtd"
+}
+
+ath10k_caldata_set_macaddr() {
+ local macaddr=$1
+
+ macaddr_2bin $macaddr | dd of=/lib/firmware/$FIRMWARE \
+ conv=notrunc bs=1 seek=6 count=6
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+. /lib/functions.sh
+. /lib/functions/system.sh
+. /lib/functions/lantiq.sh
+
+case "$FIRMWARE" in
+"ath10k/cal-pci-0000:02:00.0.bin")
+ local board=$(lantiq_board_name)
+ case $board in
+ BTHOMEHUBV5A)
+ local lan_mac=$(mtd_get_mac_binary caldata 4364)
+ local wifi_mac=$(macaddr_add "$lan_mac" 3)
+ ath10k_caldata_extract "caldata" 20480
+ ath10k_caldata_set_macaddr $wifi_mac
+ ;;
+ *)
+ ath10k_caldata_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac